#ifndef GWt_elementLigneFaisceau_SEEN
#define GWt_elementLigneFaisceau_SEEN

#include "GWt_dialog.h"
#include "abstractElement.h"
#include "GWt_abstractElement.h"
#include "GWt_dropZoneLigneFaisceau.h"

#include <Wt/WContainerWidget>

using namespace Wt;


class GWt_elementLigneFaisceau : public WContainerWidget
{
    public :
    /**
     dropZone element
     a drop zone is the basic element for a widget in the ligne faisceau drop zone area
     it should be like this :
     
     +----------+--------+---------+
     |   (--->) |  ELEM  | (-----) |
     +----------+--------+---------+
     |             NAME            |
     +----------+--------+---------+
     ELEM : Element representation, draggable object
     (----) and (---->) : Droppable zone, contain arrows or line if this element is connected to another
     NAME : editable element name
     
     At first time, the ELEM element is replace by a message.
     */
    
    GWt_elementLigneFaisceau();
    GWt_elementLigneFaisceau(abstractElement*);
    
    ~GWt_elementLigneFaisceau();
    void addElement(GWt_abstractElement* elem);
    
    inline WText* getElementName() {
        return elementName_;
    }
    
    inline WText* getElementIcon() {
        return elementName_;
    }
    
    void setElementName(std::string label);
    
    inline GWt_dropZoneLigneFaisceau* getDropZoneLeft() {
        return dropZoneLeft_;
    }

    inline GWt_dropZoneLigneFaisceau* getDropZoneRight() {
        return dropZoneRight_;
    }

private:
    
    void onClick(GWt_abstractElement*);
    void removeDone(GWt_abstractElement*);
    std::string getElementNumberInBeamLine(nomdElements el);
    void initialize_ligneFaisceau(abstractElement*);
    GWt_dialog* messageDropZone_;
    WText* firstTimeInsertMessage_;
    
    GWt_dropZoneLigneFaisceau* dropZoneLeft_;
    WContainerWidget* dragElementZone_;
    GWt_dropZoneLigneFaisceau* dropZoneRight_;
    WText* elementName_;
    
    GWt_abstractElement* abstractElement_;
};
#endif
