#include <iostream>

#include <Wt/WCssDecorationStyle>
#include <Wt/WApplication>

#include "GWt_dropZoneLigneFaisceau.h"
#include "GWt_ligneFaisceau.h"
#include "GWt_console.h"
#include "nomdElements.h"


//#define PSPA_DEBUG 1

GWt_dropZoneLigneFaisceau::GWt_dropZoneLigneFaisceau()
: WContainerWidget(){
    initialise();
}


GWt_dropZoneLigneFaisceau::~GWt_dropZoneLigneFaisceau()
{
}


void GWt_dropZoneLigneFaisceau::initialise()
{
    
    // connect mouse events
    
    mouseWentOver().connect(this, &GWt_dropZoneLigneFaisceau::mouseOver);
    mouseWentUp().connect(this, &GWt_dropZoneLigneFaisceau::mouseUp);
    mouseWentDown().connect(this, &GWt_dropZoneLigneFaisceau::mouseDown);
    mouseWentOut().connect(this, &GWt_dropZoneLigneFaisceau::mouseOut);
    mouseDragged().connect(this, &GWt_dropZoneLigneFaisceau::mouseIsDragged);
    
//    decorationStyle().setBorder (WBorder (WBorder::Dotted));
    
    // accept drops
    acceptDrops("htdocs/beam.jpg");
    acceptDrops("htdocs/rfgun.jpg");
    acceptDrops("htdocs/drift.jpg");
    acceptDrops("htdocs/cell.jpg");
    acceptDrops("htdocs/bend.jpg");
    acceptDrops("htdocs/soleno.jpg");
    acceptDrops("htdocs/fit.jpg");

    setMinimumSize(10,32);
}


void GWt_dropZoneLigneFaisceau::mouseOver(const WMouseEvent& e)
{
    // Add text
#ifdef PSPA_DEBUG
    if ( static_cast<GWt_console*> (wApp->findWidget ("console"))) {
        GWt_console* console = static_cast<GWt_console*> (wApp->findWidget ("console"));
        console->addConsoleMessage("GWt_dropZoneLigneFaisceau::mouseOver ");
        console->addConsoleMessage("button "+WMouseEvent::LeftButton);
    }
#endif
}

void GWt_dropZoneLigneFaisceau::mouseOut(const WMouseEvent& e)
{
#ifdef PSPA_DEBUG
    if ( static_cast<GWt_console*> (wApp->findWidget ("console"))) {
        GWt_console* console = static_cast<GWt_console*> (wApp->findWidget ("console"));
        console->addConsoleMessage("GWt_dropZoneLigneFaisceau::mouseOut");
    }
#endif
}

void GWt_dropZoneLigneFaisceau::mouseIsDragged(const WMouseEvent& e)
{
#ifdef PSPA_DEBUG
    if ( static_cast<GWt_console*> (wApp->findWidget ("console"))) {
        GWt_console* console = static_cast<GWt_console*> (wApp->findWidget ("console"));
        console->addConsoleMessage(" GWt_dropZoneLigneFaisceau::mouseDragged");
    }
#endif
}

void GWt_dropZoneLigneFaisceau::mouseUp(const WMouseEvent& e)
{
#ifdef PSPA_DEBUG
    if ( static_cast<GWt_console*> (wApp->findWidget ("console"))) {
        GWt_console* console = static_cast<GWt_console*> (wApp->findWidget ("console"));
        console->addConsoleMessage("GWt_dropZoneLigneFaisceau::mouseOut up");
    }
#endif
}

void GWt_dropZoneLigneFaisceau::mouseDown(const WMouseEvent& e)
{
#ifdef PSPA_DEBUG
    if ( static_cast<GWt_console*> (wApp->findWidget ("console"))) {
        GWt_console* console = static_cast<GWt_console*> (wApp->findWidget ("console"));
        console->addConsoleMessage("GWt_dropZoneLigneFaisceau::mouseDown up");
    }
#endif
}

void GWt_dropZoneLigneFaisceau::dropEvent(WDropEvent evt)
{
    
#ifdef PSPA_DEBUG
    if ( static_cast<GWt_console*> (wApp->findWidget ("console"))) {
        GWt_console* console = static_cast<GWt_console*> (wApp->findWidget ("console"));
        console->addConsoleMessage(" GWt_dropZoneLigneFaisceau::dropEvent");
    }
#endif
    
    // get LigneFaiseau widget and add new elementLigneFaiseau
    GWt_LigneFaisceau* ligneFaisceau = NULL;
    if ( static_cast<GWt_LigneFaisceau*> (wApp->findWidget ("ligneFaisceau"))) {
        ligneFaisceau = static_cast<GWt_LigneFaisceau*> (wApp->findWidget ("ligneFaisceau"));
    } else {
        return;
    }
    
    // get the type of element
    nomdElements e(evt.mimeType());
    typedElement eType = e.getElementType();
    ligneFaisceau->addElement(eType, this);
}


