#include "GWt_rfgun.h"
#include "mixedTools.h"

#include <Wt/WText>
#include <Wt/WLineEdit>
#include <Wt/WBreak>
#include <Wt/WDialog>
#include <Wt/WPushButton>

GWt_rfgun::GWt_rfgun(abstractElement* elem ,GWt_elementLigneFaisceau* elemLigne) : GWt_abstractElement(elem, elemLigne)
{
    
    string* param = beginDialog();
    
    new WText("nr of macroparticles : ",dialog_->contents());
    nmacropEdit_ = new WLineEdit(param->c_str(), dialog_->contents());
    new WBreak(dialog_->contents());
    
    new WText("sigma_t (ps) : ",dialog_->contents());
    sigma_tEdit_ = new WLineEdit( (++param)->c_str(), dialog_->contents());
    new WBreak(dialog_->contents());
    
    new WText("sigma_r (cm) : ",dialog_->contents());
    sigma_rEdit_ = new WLineEdit( (++param)->c_str(), dialog_->contents());
    new WBreak(dialog_->contents());
    
    new WText("initial kinetic energy (MeV) : ",dialog_->contents());
    E_cinEdit_ = new WLineEdit( (++param)->c_str(), dialog_->contents());
    new WBreak(dialog_->contents());
    
    new WText("sigma_Ecin (MeV) : ",dialog_->contents());
    sigma_EEdit_ = new WLineEdit( (++param)->c_str(), dialog_->contents());
    new WBreak(dialog_->contents());
    
    new WText("true number of part. in beam : ",dialog_->contents());
    nb_true_particlesEdit_ = new WLineEdit( (++param)->c_str(), dialog_->contents());
    new WBreak(dialog_->contents());
    
    // Submit
    WPushButton *submit = new WPushButton("OK",dialog_->contents());
    submit->clicked().connect(dialog_, &Wt::WDialog::accept);
    dialog_->finished().connect(this, &GWt_rfgun::dialogDone);
    
    // make image
    image_ = new WImage("htdocs/rfgun.jpg",this);
    
    // activate slots
    image_->clicked().connect(this,&GWt_abstractElement::clicked);
    
}

void GWt_rfgun::dialogDone()
{
    unsigned nbParam = abstractElement_->getNbParams();
    string* envoi = new string[nbParam+1];
    int compteur = -1;
    envoi[++compteur] = mixedTools::intToString(nbParam);
    envoi[++compteur] = labelEdit_->text().toUTF8();
    envoi[++compteur] = nmacropEdit_->text().toUTF8();
    envoi[++compteur] = sigma_tEdit_->text().toUTF8();
    envoi[++compteur] = sigma_rEdit_->text().toUTF8();
    envoi[++compteur] = E_cinEdit_->text().toUTF8();
    envoi[++compteur] = sigma_EEdit_->text().toUTF8();
    envoi[++compteur] = nb_true_particlesEdit_->text().toUTF8();
    if ( compteur !=  (int)nbParam ) {
        cerr << " GWt_rfgun::dialogDone() pb nb de parametres, compteur = " << compteur << " nbParam= " << nbParam << endl;
        return;
    }
    abstractElement_->setParametersString(envoi);
    updateLabelWidget();
    delete [] envoi;
}


WImage* GWt_rfgun::getImage() {
    return image_;
}


WString GWt_rfgun::print(){
    return WString(abstractElement_->print());
}
